unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, VirtualTrees;

type
  PPayload = ^TPayload;
  TPayload = record
    ID:Integer;
    Name: string;
  end;

  { TForm1 }

  TForm1 = class(TForm)
    VirtualStringTree1: TVirtualStringTree;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure VirtualStringTree1GetText(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: String);
    procedure VirtualStringTree1InitNode(Sender: TBaseVirtualTree; ParentNode,
      Node: PVirtualNode; var InitialStates: TVirtualNodeInitStates);
  private

  public

  end;

var
  Form1: TForm1;
  Payloads: TList;

implementation

{$R *.lfm}

function NewPayload(ID: Integer; Name: String): PPayload;
begin
  New(Result);
  Result^.ID := ID;
  Result^.Name := Name;
end;


{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);

const
  NumItems = 10;

var
  i: integer;
  rec: TPayload;
  node: PVirtualNode;
  P: PPayLoad;

begin
  VirtualStringTree1.NodeDataSize := SizeOf(PPayload);

  // populate the list
  Payloads := TList.Create;
  for i := 1 to NumItems do
    Payloads.Add(NewPayload(i, Format('Node %d', [i])));

  // initalize the nodes
  for i := 0 to Payloads.Count-1 do
    virtualStringTree1.AddChild(nil, Payloads[i]);
end;

procedure TForm1.FormDestroy(Sender: TObject);
var
  i: Integer;
  P: PPayload;
begin
  for i := Payloads.Count-1 downto 0 do
  begin
    P := PPayload(Payloads[i]);
    Dispose(P);
  end;
  Payloads.Free;
end;

procedure TForm1.VirtualStringTree1GetText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: String);
var
  p: Pointer;
begin
  p := Sender.GetNodeData(Node);
  CellText := PPayload(p^)^.Name;
end;

procedure TForm1.VirtualStringTree1InitNode(Sender: TBaseVirtualTree;
  ParentNode, Node: PVirtualNode; var InitialStates: TVirtualNodeInitStates);
begin
  assert(true,'VirtualStringTree1InitNode should never be called.');
end;

end.

